<?php

/**
 * Abstraction Class that includes common functions used by post Fields and user UserFields
 *
 * @since 1.9.2
 */
abstract class CRED_Fields_Abstract_Model {

	protected $wpdb = null;

	function __construct() {
		global $wpdb;
		$this->wpdb = $wpdb;
	}

	/**
	 * @param $fields
	 */
	protected function save_custom_fields( $fields ) {
		update_option( $this->get_custom_fields_option_name(), $fields );
	}

	/**
	 * @param $post_type
	 * @param array $exclude_fields
	 * @param bool $show_private
	 * @param $paged
	 * @param int $perpage
	 * @param string $orderby
	 * @param string $order
	 *
	 * @return mixed
	 */
	abstract public function getPostTypeCustomFields( $post_type, $exclude_fields = array(), $show_private = true, $paged, $perpage = 10, $orderby = 'meta_key', $order = 'asc' );

	/**
	 * @return mixed
	 */
	abstract public function getAllFields();

	/**
	 * @param null $post_type
	 * @param bool $force_all
	 *
	 * @return mixed
	 */
	abstract public function getCustomFields( $post_type = null, $force_all = false );

	/**
	 * @return mixed
	 */
	abstract protected function get_custom_fields_option_name();
}
